# OsiGrbSolverInterface Class Reference

Gurobi Solver Interface. More...

`#include <OsiGrbSolverInterface.hpp>`

Inheritance diagram for OsiGrbSolverInterface:
[legend]
Collaboration diagram for OsiGrbSolverInterface:
[legend]

List of all members.

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
const char * | getCtype () const
| return a vector of variable types (continous, binary, integer)
virtual OsiSolverInterface::ApplyCutsReturnCode | applyCuts (const OsiCuts &cs, double effectivenessLb=0.0)
| Apply a collection of cuts.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter.
bool | setHintParam (OsiHintParam key, bool yesNo=true, OsiHintStrength strength=OsiHintTry, void *=NULL)
| Set a hint parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength, void *&otherInformation) const
| Get a hint parameter (all information).
bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength) const
| Get a hint parameter (sense and strength only).
bool | getHintParam (OsiHintParam key, bool &yesNo) const
| Get a hint parameter (sense only).
void | setMipStart (bool value)
bool | getMipStart () const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a a set of objective function coefficients.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes `setColLower()` and `setColUpper()`.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes `setCollower()` and `setColupper()` over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes `setRowLower()` and `setRowUpper()`.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes `setRowType()` and over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Naming methods
virtual void | setRowName (int ndx, std::string name)
| Set a row name.
virtual void | setColName (int ndx, std::string name)
| Set a column name.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Constructors and destructor
| OsiGrbSolverInterface (bool use_local_env=false)
| Default Constructor.
| OsiGrbSolverInterface (GRBenv *localgrbenv)
| Constructor that takes a gurobi environment and assumes membership.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiGrbSolverInterface (const OsiGrbSolverInterface &)
| Copy constructor.
OsiGrbSolverInterface & | operator= (const OsiGrbSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiGrbSolverInterface ()
| Destructor.
virtual void | reset ()
| Resets as if default constructor.
OsiSimplexInterface methods
Gurobi adds a slack with coeff +1 in "<=" and "=" constraints, with coeff -1 in ">=", slack being non negative. We switch in order to get a "Clp tableau" where all the slacks have coefficient +1 in the original tableau. If a slack for ">=" is non basic, invB is not changed; column of the slack in the optimal tableau is flipped. If a slack for ">=" is basic, corresp. row of invB is flipped; whole row of the optimal tableau is flipped; then whole column for the slack in opt tableau is flipped. Ranged rows are not supported. It might work, but no garantee is given.
virtual int | canDoSimplexInterface () const
| Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.
virtual void | enableSimplexInterface (int doingPrimal)
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | disableSimplexInterface ()
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | enableFactorization () const
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | disableFactorization () const
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual bool | basisIsAvailable () const
| Returns true if a basis is available.
virtual void | getBasisStatus (int *cstat, int *rstat) const
| Returns a basis status of the structural/artificial variables At present as warm start i.e 0: free, 1: basic, 2: upper, 3: lower.
void | switchToLP ()
| Get indices of the pivot variable in each row (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).
void | switchToMIP ()
| switches Gurobi to prob type MIP
## Static Public Member Functions
Static instance counter methods
static void | incrementInstanceCounter ()
| Gurobi has a context which must be created prior to all other Gurobi calls.
static void | decrementInstanceCounter ()
| Gurobi has a context which should be deleted after Gurobi calls.
static void | setEnvironment (GRBenv *globalenv)
| sets the global gurobi environment to a user given one
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using Gurobi services.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
## Private Member Functions
Private static class functions
void | resizeColSpace (int minsize)
| resizes coltype_, colmap_O2G, colmap_G2O vectors to be able to store at least minsize elements
void | freeColSpace ()
| frees colsize_ vector
void | resizeAuxColSpace (int minsize)
| resizes colmap_G2O vector to be able to store at least minsize (auxiliary) elements
void | resizeAuxColIndSpace ()
| resizes auxcolind vector to current number of rows and inits values to -1
Private methods
GRBmodel * | getMutableLpPtr () const
| Get LP Pointer for const methods.
void | gutsOfCopy (const OsiGrbSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment).
void | gutsOfConstructor ()
| The real work of the constructor.
void | gutsOfDestructor ()
| The real work of the destructor.
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory
void | convertToRangedRow (int rowidx, double rhs, double range)
| converts a normal row into a ranged row by adding an auxiliary variable
void | convertToNormalRow (int rowidx, char sense, double rhs)
| converts a ranged row into a normal row by removing its auxiliary variable
## Private Attributes
Private member data
GRBenv * | localenv_
| Gurobi environment used only by this class instance.
GRBmodel * | lp_
| Gurobi model represented by this class instance.
int * | hotStartCStat_
| Hotstart information.
int | hotStartCStatSize_
| Gurobi environment used only by this class instance.
int * | hotStartRStat_
| Gurobi environment used only by this class instance.
int | hotStartRStatSize_
| Gurobi environment used only by this class instance.
int | hotStartMaxIteration_
| Gurobi environment used only by this class instance.
int | nameDisc_
| OSI name discipline.
Cached information derived from the Gurobi model
double * | obj_
| Pointer to objective vector.
double * | collower_
| Pointer to dense vector of variable lower bounds.
double * | colupper_
| Pointer to dense vector of variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | rowlower_
| Pointer to dense vector of row lower bounds.
double * | rowupper_
| Pointer to dense vector of row upper bounds.
double * | colsol_
| Pointer to primal solution vector.
double * | rowsol_
| Pointer to dual solution vector.
double * | redcost_
| Pointer to reduced cost vector.
double * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
Additional information needed for storing MIP problems and handling ranged rows
bool | probtypemip_
| Stores whether we currently see the problem as a MIP.
bool | domipstart
| Whether to pass a column solution to CPLEX before starting MIP solve (copymipstart).
int | colspace_
| Size of allocated memory for coltype_, colmap_O2G, and (with offset auxcolspace) colmap_G2O.
char * | coltype_
| Pointer to dense vector of variable types (continous, binary, integer).
int | nauxcols
| Number of auxiliary columns in Gurobi model for handling of ranged rows.
int | auxcolspace
| Size of allocated memory for colmap_G2O that exceeds colspace_.
int * | colmap_O2G
| Maps variable indices from Osi to Gurobi Is NULL if there are no ranged rows! (assume identity mapping then).
int * | colmap_G2O
| Maps variable indices from Gurobi to Osi A negative value indicates that a variable is an auxiliary variable that was added to handle a ranged row -colmap_G2O[i]-1 gives the index of the ranged row in this case.
int | auxcolindspace
| Current length of auxcolind array.
int * | auxcolind
| Gives for each row the index of the corresponding auxiliary variable, if it is a ranged row.
## Static Private Attributes
Private static class data
static GRBenv * | globalenv_
| Gurobi environment pointer.
static bool | globalenv_is_ours
| whether OsiGrb has created the global environment (and thus should free it)
static unsigned int | numInstances_
| Number of instances using the global Gurobi environment.
## Friends
void | OsiGrbSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiGrbSolverInterface class.
## Gurobi specific public interfaces
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
| Get pointer to Gurobi model and free all specified cached data entries (combined with logical or-operator '|' ):. More...
GRBmodel * | getLpPtr (int keepCached=KEEPCACHED_NONE)
| Get pointer to Gurobi model and free all specified cached data entries (combined with logical or-operator '|' ):.
GRBenv * | getEnvironmentPtr () const
| Method to access Gurobi environment pointer.
bool | isDemoLicense () const
| Return whether the current Gurobi environment runs in demo mode.

## Detailed Description

Gurobi Solver Interface.

Instantiation of OsiGrbSolverInterface for Gurobi

Definition at line 29 of file OsiGrbSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiGrbSolverInterface::keepCachedFlag

Get pointer to Gurobi model and free all specified cached data entries (combined with logical or-operator '|' ):.

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 546 of file OsiGrbSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiGrbSolverInterface::OsiGrbSolverInterface | ( | bool | use_local_env = `false` | ) |

Default Constructor.

OsiGrbSolverInterface::OsiGrbSolverInterface | ( | GRBenv * | localgrbenv | ) |

Constructor that takes a gurobi environment and assumes membership.

OsiGrbSolverInterface::OsiGrbSolverInterface | ( | const OsiGrbSolverInterface & |  | ) |

Copy constructor.

virtual OsiGrbSolverInterface::~OsiGrbSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiGrbSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiGrbSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::setHintParam | ( | OsiHintParam | key,
|  | bool | yesNo = `true`,
|  | OsiHintStrength | strength = `OsiHintTry`,
|  | void * | = `NULL` |
| ) |  |  | `[virtual]`

Set a hint parameter.

The `otherInformation` parameter can be used to pass in an arbitrary block of information which is interpreted by the OSI and the underlying solver. Users are cautioned that this hook is solver-specific.

Implementors: The default implementation completely ignores `otherInformation` and always throws an exception for OsiForceDo. This is almost certainly not the behaviour you want; you really should override this method.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo,
|  | OsiHintStrength & | strength,
|  | void *& | otherInformation |
| ) |  |  | const`[virtual]`

Get a hint parameter (all information).

Return all available information for the hint: sense, strength, and any extra information associated with the hint.

Implementors: The default implementation will always set `otherInformation` to NULL. This is almost certainly not the behaviour you want; you really should override this method.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo,
|  | OsiHintStrength & | strength |
| ) |  |  | const`[virtual]`

Get a hint parameter (sense and strength only).

Return only the sense and strength of the hint.

Reimplemented from OsiSolverInterface.

bool OsiGrbSolverInterface::getHintParam | ( | OsiHintParam | key,
|  | bool & | yesNo |
| ) |  |  | const`[virtual]`

Get a hint parameter (sense only).

Return only the sense (true/false) of the hint.

Reimplemented from OsiSolverInterface.

void OsiGrbSolverInterface::setMipStart | ( | bool | value | ) | `[inline]`

Definition at line 84 of file OsiGrbSolverInterface.hpp.

bool OsiGrbSolverInterface::getMipStart | ( |  | ) | const`[inline]`

Definition at line 86 of file OsiGrbSolverInterface.hpp.

virtual bool OsiGrbSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

CoinWarmStart* OsiGrbSolverInterface::getEmptyWarmStart | ( |  | ) | const`[virtual]`

Get an empty warm start object.

This routine returns an empty CoinWarmStartBasis object. Its purpose is to provide a way to give a client a warm start basis object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiGrbSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiGrbSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiGrbSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiGrbSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiGrbSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiGrbSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiGrbSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiGrbSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiGrbSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiGrbSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiGrbSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiGrbSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiGrbSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiGrbSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiGrbSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setObjCoeffSet | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | coeffList |
| ) |  |  | `[virtual]`

Set a a set of objective function coefficients.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes `setColLower()` and `setColUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes `setCollower()` and `setColupper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes `setRowLower()` and `setRowUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes `setRowType()` and over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose type changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a row name.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a column name.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiGrbSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

GRBmodel* OsiGrbSolverInterface::getLpPtr | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

Get pointer to Gurobi model and free all specified cached data entries (combined with logical or-operator '|' ):.

GRBenv* OsiGrbSolverInterface::getEnvironmentPtr | ( |  | ) | const

Method to access Gurobi environment pointer.

bool OsiGrbSolverInterface::isDemoLicense | ( |  | ) | const

Return whether the current Gurobi environment runs in demo mode.

const char* OsiGrbSolverInterface::getCtype | ( |  | ) | const

return a vector of variable types (continous, binary, integer)

static void OsiGrbSolverInterface::incrementInstanceCounter | ( |  | ) | `[static]`

Gurobi has a context which must be created prior to all other Gurobi calls.

This method:

- Increments by 1 the number of uses of the Gurobi environment.
- Creates the Gurobi context when the number of uses is change to 1 from 0.

static void OsiGrbSolverInterface::decrementInstanceCounter | ( |  | ) | `[static]`

Gurobi has a context which should be deleted after Gurobi calls.

This method:

- Decrements by 1 the number of uses of the Gurobi environment.
- Deletes the Gurobi context when the number of uses is change to 0 from 1.

static void OsiGrbSolverInterface::setEnvironment | ( | GRBenv * | globalenv | ) | `[static]`

sets the global gurobi environment to a user given one

static unsigned int OsiGrbSolverInterface::getNumInstances | ( |  | ) | `[static]`

Return the number of instances of instantiated objects using Gurobi services.

virtual OsiSolverInterface* OsiGrbSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiGrbSolverInterface& OsiGrbSolverInterface::operator= | ( | const OsiGrbSolverInterface & | rhs | ) |

Assignment operator.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::reset | ( |  | ) | `[virtual]`

Resets as if default constructor.

Reimplemented from OsiSolverInterface.

virtual int OsiGrbSolverInterface::canDoSimplexInterface | ( |  | ) | const`[virtual]`

Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::enableSimplexInterface | ( | int | doingPrimal | ) | `[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Definition at line 665 of file OsiGrbSolverInterface.hpp.

virtual void OsiGrbSolverInterface::disableSimplexInterface | ( |  | ) | `[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 672 of file OsiGrbSolverInterface.hpp.

virtual void OsiGrbSolverInterface::enableFactorization | ( |  | ) | const`[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 679 of file OsiGrbSolverInterface.hpp.

virtual void OsiGrbSolverInterface::disableFactorization | ( |  | ) | const`[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 686 of file OsiGrbSolverInterface.hpp.

virtual bool OsiGrbSolverInterface::basisIsAvailable | ( |  | ) | const`[virtual]`

Returns true if a basis is available.

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::getBasisStatus | ( | int * | cstat,
|  | int * | rstat |
| ) |  |  | const`[virtual]`

Returns a basis status of the structural/artificial variables At present as warm start i.e 0: free, 1: basic, 2: upper, 3: lower.

Reimplemented from OsiSolverInterface.

void OsiGrbSolverInterface::switchToLP | ( |  | ) |

Get indices of the pivot variable in each row (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).

switches Gurobi to prob type LP

void OsiGrbSolverInterface::switchToMIP | ( |  | ) |

switches Gurobi to prob type MIP

virtual OsiSolverInterface::ApplyCutsReturnCode OsiGrbSolverInterface::applyCuts | ( | const OsiCuts & | cs,
|  | double | effectivenessLb = `0.0` |
| ) |  |  | `[virtual]`

Apply a collection of cuts.

Only cuts which have an `effectiveness >= effectivenessLb` are applied.

- ReturnCode.getNumineffective() -- number of cuts which were not applied because they had an `effectiveness < effectivenessLb`
- ReturnCode.getNuminconsistent() -- number of invalid cuts
- ReturnCode.getNuminconsistentWrtIntegerModel() -- number of cuts that are invalid with respect to this integer model
- ReturnCode.getNuminfeasible() -- number of cuts that would make this integer model infeasible
- ReturnCode.getNumApplied() -- number of integer cuts which were applied to the integer model
- cs.size() == getNumineffective() + getNuminconsistent() + getNuminconsistentWrtIntegerModel() + getNuminfeasible() + getNumApplied()

Reimplemented from OsiSolverInterface.

virtual void OsiGrbSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiGrbSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiGrbSolverInterface::resizeColSpace | ( | int | minsize | ) | `[private]`

resizes coltype_, colmap_O2G, colmap_G2O vectors to be able to store at least minsize elements

void OsiGrbSolverInterface::freeColSpace | ( |  | ) | `[private]`

frees colsize_ vector

void OsiGrbSolverInterface::resizeAuxColSpace | ( | int | minsize | ) | `[private]`

resizes colmap_G2O vector to be able to store at least minsize (auxiliary) elements

void OsiGrbSolverInterface::resizeAuxColIndSpace | ( |  | ) | `[private]`

resizes auxcolind vector to current number of rows and inits values to -1

GRBmodel* OsiGrbSolverInterface::getMutableLpPtr | ( |  | ) | const`[private]`

Get LP Pointer for const methods.

void OsiGrbSolverInterface::gutsOfCopy | ( | const OsiGrbSolverInterface & | source | ) | `[private]`

The real work of a copy constructor (used by copy and assignment).

void OsiGrbSolverInterface::gutsOfConstructor | ( |  | ) | `[private]`

The real work of the constructor.

void OsiGrbSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of the destructor.

void OsiGrbSolverInterface::freeCachedColRim | ( |  | ) | `[private]`

free cached column rim vectors

void OsiGrbSolverInterface::freeCachedRowRim | ( |  | ) | `[private]`

free cached row rim vectors

void OsiGrbSolverInterface::freeCachedResults | ( |  | ) | `[private]`

free cached result vectors

void OsiGrbSolverInterface::freeCachedMatrix | ( |  | ) | `[private]`

free cached matrices

void OsiGrbSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) | `[private]`

free all cached data (except specified entries, see getLpPtr())

void OsiGrbSolverInterface::freeAllMemory | ( |  | ) | `[private]`

free all allocated memory

void OsiGrbSolverInterface::convertToRangedRow | ( | int | rowidx,
|  | double | rhs,
|  | double | range |
| ) |  |  | `[private]`

converts a normal row into a ranged row by adding an auxiliary variable

void OsiGrbSolverInterface::convertToNormalRow | ( | int | rowidx,
|  | char | sense,
|  | double | rhs |
| ) |  |  | `[private]`

converts a ranged row into a normal row by removing its auxiliary variable

## Friends And Related Function Documentation

void OsiGrbSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiGrbSolverInterface class.

## Member Data Documentation

GRBenv* OsiGrbSolverInterface::globalenv_`[static, private]`

Gurobi environment pointer.

Definition at line 784 of file OsiGrbSolverInterface.hpp.

bool OsiGrbSolverInterface::globalenv_is_ours`[static, private]`

whether OsiGrb has created the global environment (and thus should free it)

Definition at line 786 of file OsiGrbSolverInterface.hpp.

unsigned int OsiGrbSolverInterface::numInstances_`[static, private]`

Number of instances using the global Gurobi environment.

Definition at line 788 of file OsiGrbSolverInterface.hpp.

GRBenv* OsiGrbSolverInterface::localenv_`[mutable, private]`

Gurobi environment used only by this class instance.

Definition at line 835 of file OsiGrbSolverInterface.hpp.

GRBmodel* OsiGrbSolverInterface::lp_`[mutable, private]`

Gurobi model represented by this class instance.

Definition at line 838 of file OsiGrbSolverInterface.hpp.

int* OsiGrbSolverInterface::hotStartCStat_`[private]`

Hotstart information.

Definition at line 841 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::hotStartCStatSize_`[private]`

Gurobi environment used only by this class instance.

Definition at line 842 of file OsiGrbSolverInterface.hpp.

int* OsiGrbSolverInterface::hotStartRStat_`[private]`

Gurobi environment used only by this class instance.

Definition at line 843 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::hotStartRStatSize_`[private]`

Gurobi environment used only by this class instance.

Definition at line 844 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::hotStartMaxIteration_`[private]`

Gurobi environment used only by this class instance.

Definition at line 845 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::nameDisc_`[private]`

OSI name discipline.

Definition at line 848 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::obj_`[mutable, private]`

Pointer to objective vector.

Definition at line 853 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::collower_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 856 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::colupper_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 859 of file OsiGrbSolverInterface.hpp.

char* OsiGrbSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 862 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 865 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 868 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rowlower_`[mutable, private]`

Pointer to dense vector of row lower bounds.

Definition at line 871 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rowupper_`[mutable, private]`

Pointer to dense vector of row upper bounds.

Definition at line 874 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::colsol_`[mutable, private]`

Pointer to primal solution vector.

Definition at line 877 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rowsol_`[mutable, private]`

Pointer to dual solution vector.

Definition at line 880 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::redcost_`[mutable, private]`

Pointer to reduced cost vector.

Definition at line 883 of file OsiGrbSolverInterface.hpp.

double* OsiGrbSolverInterface::rowact_`[mutable, private]`

Pointer to row activity (slack) vector.

Definition at line 886 of file OsiGrbSolverInterface.hpp.

CoinPackedMatrix* OsiGrbSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 889 of file OsiGrbSolverInterface.hpp.

CoinPackedMatrix* OsiGrbSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 892 of file OsiGrbSolverInterface.hpp.

bool OsiGrbSolverInterface::probtypemip_`[mutable, private]`

Stores whether we currently see the problem as a MIP.

Definition at line 898 of file OsiGrbSolverInterface.hpp.

bool OsiGrbSolverInterface::domipstart`[private]`

Whether to pass a column solution to CPLEX before starting MIP solve (copymipstart).

Definition at line 901 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::colspace_`[private]`

Size of allocated memory for coltype_, colmap_O2G, and (with offset auxcolspace) colmap_G2O.

Definition at line 904 of file OsiGrbSolverInterface.hpp.

char* OsiGrbSolverInterface::coltype_`[private]`

Pointer to dense vector of variable types (continous, binary, integer).

Definition at line 907 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::nauxcols`[private]`

Number of auxiliary columns in Gurobi model for handling of ranged rows.

Definition at line 910 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::auxcolspace`[private]`

Size of allocated memory for colmap_G2O that exceeds colspace_.

Definition at line 913 of file OsiGrbSolverInterface.hpp.

int* OsiGrbSolverInterface::colmap_O2G`[private]`

Maps variable indices from Osi to Gurobi Is NULL if there are no ranged rows! (assume identity mapping then).

Definition at line 917 of file OsiGrbSolverInterface.hpp.

int* OsiGrbSolverInterface::colmap_G2O`[private]`

Maps variable indices from Gurobi to Osi A negative value indicates that a variable is an auxiliary variable that was added to handle a ranged row -colmap_G2O[i]-1 gives the index of the ranged row in this case.

Is NULL if there are no ranged rows! (assume identity mapping then)

Definition at line 923 of file OsiGrbSolverInterface.hpp.

int OsiGrbSolverInterface::auxcolindspace`[private]`

Current length of auxcolind array.

Definition at line 926 of file OsiGrbSolverInterface.hpp.

int* OsiGrbSolverInterface::auxcolind`[private]`

Gives for each row the index of the corresponding auxiliary variable, if it is a ranged row.

Otherwise, gives -1. Is NULL if there are no ranged rows! (assume -1 for each row then)

Definition at line 931 of file OsiGrbSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Blis-0.93.10/Osi/src/OsiGrb/OsiGrbSolverInterface.hpp